#ifndef AMIGO_H_
#define AMIGO_H_
#include "db_utils.h"
#include "defines.h"
int amigo_char(unsigned char ch, unsigned char atn, unsigned char reset);
void amigo_init(void);
void amigo_cmd_send_status(void);
void amigo_cmd_seek(void);
void amigo_cmd_buffered_read(void);
void amigo_cmd_buffered_write(void);
void amigo_cmd_dsj(void);
void amigo_cmd_wakeup(void);
void amigo_cmd_clear(void);
void amigo_increment(void);
void amigo_cmd_unbuffered_read(void);
void amigo_cmd_unbuffered_write(void);
void amigo_cmd_format(void);

extern unsigned volatile int amigo_state;
//extern char buffer[256];
extern unsigned char amigo_buff_flag;
extern unsigned char amigo_error;
//
#define AMIGO_BUFFERED      0   // Read and write is buffered
#define AMIGO_UNBUFFERED    1   // Read and write is unbuffered
//
// State-machine states
//
#define AMIGO_START 		0
#define AMIGO_060_T			6000
#define AMIGO_06C_L         6700
#define AMIGO_06C_FORMAT    6701
#define AMIGO_06C_FORMAT1   6702
#define AMIGO_06C_FORMAT2   6703
#define AMIGO_06C_FORMAT3   6704
#define AMIGO_068_L			6800
#define AMIGO_068_T			6850
#define AMIGO_068_STATUS	6801
#define AMIGO_068_SEEK		6802
#define AMIGO_068_SEEK_1	6811
#define AMIGO_068_SEEK_2	6812
#define AMIGO_068_SEEK_3	6813
#define AMIGO_068_SEEK_4	6814
#define AMIGO_068_WAKEUP	6820
#define AMIGO_068_READ      6830
#define AMIGO_068_VERIFY    6840
#define AMIGO_068_VERIFY_1    6841
#define AMIGO_068_VERIFY_2    6842
#define AMIGO_068_VERIFY_3    6843
#define AMIGO_06A			6900
#define AMIGO_06A_READ		6901
#define AMIGO_06A_READ_1	6902
#define AMIGO_06A_READ_2	6903
#define AMIGO_070_T			7000
#define AMIGO_070_L			7010
#define AMIGO_070_L_1		7011

#define AMIGO_END			9999

// Returned command codes
#define AMIGO_CMD_SEEK			1
#define AMIGO_CMD_SEND_STATUS	2
#define AMIGO_CMD_BUFFERED_READ	3
#define AMIGO_CMD_DSJ			4
#define AMIGO_CMD_BUFFERED_WRITE 5
#define AMIGO_CMD_WAKEUP 		6
#define AMIGO_CMD_CLEAR			7
#define AMIGO_CMD_UNBUFFERED_READ	8
#define AMIGO_CMD_UNBUFFERED_WRITE 9
#define AMIGO_CMD_FORMAT        10

#define MLA		0x20		// My listen address = 0 (0+0x20)
#define	MTA		0x40		// My talk address = 0 (0+0x40)
#define	UNL		0x3F		// Unlisten
#define UNT		0x5F		// Untalk
#define	LLO		0x11		// Local lockout
#define	DCL		0x14		// Device clear
#define	PPU		0x15		// Parallell poll unconfigure
#define SPE		0x18		// Serial poll enable
#define	SPD		0x19		// Serial poll disable
#define	GTL		0x01		// Go to local
#define SDC		0x04		// Selected device clear
#define PPC		0x05		// Parallell poll configure
#define GET		0x08		// Group execute trigger
#define TCT		0x09		// Take control

//typedef struct {
//int LIFid;
//char label[6];
//int dirstarthi;
//int dirstartlo;
//int s3000;
//int dummy;
//int dirlenhi;
//int dirlenlo;
//int version;
//} VolumeLabelType;
//
//
//typedef struct {
//	char filename[10];
//	int filetype;
//	int startaddhi;
//	int startaddlo;
//	int lengthhi;
//	int lengthlo;
//	char createtime[6];	// BCD digits
//	int volnumber;
//	int implementationhi;
//	int implementationlo;
//} DirEntryType;


extern VolumeLabelType vl;
extern DirEntryType de;
extern DiskType Disk;


#endif