/*-------------------------------------------------------------------------
  defines.h - global defines

             (c) 2014-2019 Anders Gustafsson <anders.gustafsson@pedago.fi> 

-------------------------------------------------------------------------*/
#define _XTAL_FREQ 64000000
#define MAX_DBG_STRING 64
#define PARMLEN 15	// Max length of parameter or value i hpdisk.cfg
#define MAXFN 15    // Max length of LIF file name
#define MAXDISK 3   // Maximum disk number, ie number of disks - 1
                    // define any reasonable number here as long as you have
                    // memory to spare
#define SDEBUG	1	// Turns on debug output
					// 0 - none
					// 1 - Just commands
					// 2 - Commands and packet dump
					// 9 - Individual GPIB bytes

//#define SPOLL		// Defined if we support a response to serial poll
//
// Supported drives. Define one for Amigo, one for SS/80
//
#define HP9121D			// HP9121 dual 270K AMIGO floppy drive
#define HP9122D		// HP9122 dual 630K SS/80 floppy drive
//#define HP9134L		// HP9134L 40M SS/80 Winchester drive
//#define HP7911          // HP1711 HP7911 28M CS/80 hard drive
#include "integer.h"

#define MLA		0x20		// My listen address = 0 (0+0x20)
#define	MTA		0x40		// My talk address = 0 (0+0x40)
#define	UNL		0x3F		// Unlisten
#define UNT		0x5F		// Untalk
#define	LLO		0x11		// Local lockout
#define	DCL		0x14		// Device clear
#define	PPU		0x15		// Parallell poll unconfigure
#define SPE		0x18		// Serial poll enable
#define	SPD		0x19		// Serial poll disable
#define	GTL		0x01		// Go to local
#define SDC		0x04		// Selected device clear
#define PPC		0x05		// Parallell poll configure
#define GET		0x08		// Group execute trigger
#define TCT		0x09		// Take control

#if defined(HP9121D)
//#warning Compiled for a HP 9121D Amigo floppy
// 9895  0081
// 9121D 0104
// 9134A 0106 (winchester))
#define AMIGOID1 0x01
#define AMIGOID2 0x04
#else
#error You must define an Amigo-floppy in defines.h
#endif

#if defined(HP9122D)
//#warning Compiled for a HP 9122D SS/80 floppy
#define SS80ID1 0x02
#define SS80ID2 0x22
#elif defined(HP9134L)
//#warning Compiled for a HP 9134L 40M SS/80 Winchester drive
#define SS80ID1 0x02
#define SS80ID2 0x21
#elif defined(HP7911)
//#warning Compiled for a HP 7911 17M CS/80 Winchester drive
#define SS80ID1 0x02
#define SS80ID2 0x04
#else
#error You must define a SS/80 floppy in defines.h
#endif

#define SS80_ERR_READ 	0b00000001
#define SS80_ERR_WRITE 	0b00000010
#define SS80_ERR_SEEK	0b00000100
