// EEPROM routines from the MCC

#include <xc.h>
#include "eeprom.h"



void DATAEE_WriteByte(int bAdd, char bData)
{
	char GIEBitValue = INTCONbits.GIE;   // Save interrupt enable

    NVMADRH = ((bAdd >> 8) & 0x03);
    NVMADRL = (bAdd & 0xFF);
    NVMDAT = bData;
    NVMCON1bits.NVMREG = 0;
    NVMCON1bits.WREN = 1;
	INTCONbits.GIE = 0;     // Disable interrupts
    NVMCON2 = 0x55;
    NVMCON2 = 0xAA;
    NVMCON1bits.WR = 1;
    // Wait for write to complete
    while (NVMCON1bits.WR)
    {
    }

    NVMCON1bits.WREN = 0;
	INTCONbits.GIE = GIEBitValue;   // Restore interrupt enable
}

char DATAEE_ReadByte(int bAdd)
{
    NVMADRH = ((bAdd >> 8) & 0x03);
    NVMADRL = (bAdd & 0xFF);
    NVMCON1bits.NVMREG = 0;
    NVMCON1bits.RD = 1;
    NOP();  // NOPs may be required for latency at high frequencies
    NOP();

    return (NVMDAT);
}
