#include "lifdisk.h"
#include "xprintf.h"
//
// https://www.hp9845.net/9845/projects/hpdir/
//
extern char gpib_tx_buff[512];
// Data for HP LIF-format disks
//
VolumeLabelType vl = {0x0080,{'L','A','B','E','L','1'},
0,0x200,
0x0080,
0,
0,0x0e00,						// Change this to 0x0e -> LIF directory too big
0
};
//
// Directory entry
//
DirEntryType de = {{'M','Y','F','I','L','E','1','2','3','4'},0x100,0,0x100,0,0x20,{0x13,0x10,0x12,0x00,0x00,0x00},1,0,0};
//
// Structure to hold head/cylinder/sector
//
DiskType Disk = {0,0,0,0};

//
// Find the corresponding vector for a file. Only checks the first sector of the directory
// error return is 0 as the file cannot be on sector 0
DWORD FindFile(FIL file, char *name)
{
    char *buffer = gpib_tx_buff;
    FRESULT rc;
    UINT nbytes;
    UINT dirstart;
    DWORD vector;
    int i;
    char *ptr;
    char l = strlen(name);
    //
    rc=f_lseek(&file,0);
    if(rc)
    {
        xprintf("FindFile failed search\r\n");
        return 0;
    }
    rc=f_read(&file,buffer,256,&nbytes ); 
    if(rc)
    {
        xprintf("FindFile failed read\r\n");
        return 0;
    }
    if(buffer[0] != 0x80)
    {
        xprintf("Not a LIF disk\r\n");
        return 0;
    }
    dirstart = buffer[11]+256*buffer[10];   // Todo: This is really 4 bytes
    xprintf("Seeking to sector %X\r\n", dirstart);
    rc=f_lseek(&file,dirstart*256);
    if(rc) return 0;
    rc=f_read(&file,buffer,256,&nbytes ); 
    if(rc) return 0;
    //
    // Look for files
    //
    for(i=0;i<15;i++)
    {
        //xprintf("%d: %X %s \r\n",i,32*i,&buffer[32*i]);
        if(!strncmp(name, &buffer[32*i], l))
        {
            //xprintf("Found %s at %X\r\n", name, 32*i);
            vector = buffer[32*i+15]+buffer[32*i+14]*256;
            xprintf("Vector is %X\r\n", vector);
            return vector;
        }
    }
    return 0;
}